#include "neighborhoodWidget.hpp"
#include "ui_neighborhoodWidget.h"

#include <QDate>
#include <QMessageBox>

NeighborhoodWidget::NeighborhoodWidget(QWidget *parent) :
      QWidget(parent), ui(new Ui::NeighborhoodWidget)
{
    ui->setupUi(this);
    GridView& gv = *(*ui).grid_view;
    Alphabet a;

    // Création des états à partir du constructeur
    state* black = new state(stateColor(0,0,0),"Black");
    state* blue = new state(stateColor(0,0,255),"Blue");
    state* grey = new state(stateColor(127,127,127),"Grey");

    // Ajout des états dans l'Alphabet
    a.newEtat(*black);
    a.newEtat(*blue);
    a.newEtat(*grey);

    gv.set_alphabet(a);


    QSize size = gv.grid_size();
    currentPoint = {size.width() / 2, size.height() / 2};
    Grid newGrid(gv.get_grid());
    newGrid.set_cell(currentPoint, 2);
    gv.copy_grid(newGrid);
    gv.enable_toggle_mode(1, 0);
    // TODO le clic sur la cellule centrale
}

NeighborhoodWidget::~NeighborhoodWidget()
{
    delete ui;
}

Neighborhood* NeighborhoodWidget::getVoisinage() const
{
    return nullptr;
}

QPushButton* NeighborhoodWidget::getValidateButton() const {
    return ui->validationButton;
}

GridView& NeighborhoodWidget::getGridView() const{
    return *(ui->grid_view);
}

Neighborhood& NeighborhoodWidget::getNeighborhood() const
{
    Neighborhood* newNeighborhood = new Neighborhood;
    Grid currentGrid = ui->grid_view->get_grid();
    QSize currentSizeGrid = ui->grid_view->grid_size();
    int height = currentSizeGrid.height();
    int width = currentSizeGrid.width();
    for(int j = 0; j < height ; j++) {
        for(int i = 0; i < width ; i++) {
            if( currentGrid.get_state({i,j}) == 1) {
                Coord newCoord = {i - currentPoint.x, j - currentPoint.y};
                newNeighborhood->addNeighbor(newCoord, 1);
                std::cout << "Nouveau voisin : X=" << newCoord.x << " Y=" << newCoord.y << endl;
                fflush(stdout);
            }
        }
    }
    return *newNeighborhood;
}
